const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Market_signalsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const market_signals = await db.market_signals.create(
      {
        id: data.id || undefined,

        competitor: data.competitor || null,
        type: data.type || null,
        description: data.description || null,
        date_detected: data.date_detected || null,
        impact_score: data.impact_score || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await market_signals.setOrganization(currentUser.organization.id || null, {
      transaction,
    });

    await market_signals.setOrganizations(data.organizations || null, {
      transaction,
    });

    return market_signals;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const market_signalsData = data.map((item, index) => ({
      id: item.id || undefined,

      competitor: item.competitor || null,
      type: item.type || null,
      description: item.description || null,
      date_detected: item.date_detected || null,
      impact_score: item.impact_score || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const market_signals = await db.market_signals.bulkCreate(
      market_signalsData,
      { transaction },
    );

    // For each item created, replace relation files

    return market_signals;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const market_signals = await db.market_signals.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.competitor !== undefined)
      updatePayload.competitor = data.competitor;

    if (data.type !== undefined) updatePayload.type = data.type;

    if (data.description !== undefined)
      updatePayload.description = data.description;

    if (data.date_detected !== undefined)
      updatePayload.date_detected = data.date_detected;

    if (data.impact_score !== undefined)
      updatePayload.impact_score = data.impact_score;

    updatePayload.updatedById = currentUser.id;

    await market_signals.update(updatePayload, { transaction });

    if (data.organization !== undefined) {
      await market_signals.setOrganization(
        globalAccess ? data.organization : currentUser.organization.id,
        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await market_signals.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return market_signals;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const market_signals = await db.market_signals.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of market_signals) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of market_signals) {
        await record.destroy({ transaction });
      }
    });

    return market_signals;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const market_signals = await db.market_signals.findByPk(id, options);

    await market_signals.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await market_signals.destroy({
      transaction,
    });

    return market_signals;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const market_signals = await db.market_signals.findOne(
      { where },
      { transaction },
    );

    if (!market_signals) {
      return market_signals;
    }

    const output = market_signals.get({ plain: true });

    output.organization = await market_signals.getOrganization({
      transaction,
    });

    output.organizations = await market_signals.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organization',
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.competitor) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'market_signals',
            'competitor',
            filter.competitor,
          ),
        };
      }

      if (filter.description) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'market_signals',
            'description',
            filter.description,
          ),
        };
      }

      if (filter.date_detectedRange) {
        const [start, end] = filter.date_detectedRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            date_detected: {
              ...where.date_detected,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            date_detected: {
              ...where.date_detected,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.impact_scoreRange) {
        const [start, end] = filter.impact_scoreRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            impact_score: {
              ...where.impact_score,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            impact_score: {
              ...where.impact_score,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.type) {
        where = {
          ...where,
          type: filter.type,
        };
      }

      if (filter.organization) {
        const listItems = filter.organization.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationId: { [Op.or]: listItems },
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.market_signals.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('market_signals', 'competitor', query),
        ],
      };
    }

    const records = await db.market_signals.findAll({
      attributes: ['id', 'competitor'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['competitor', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.competitor,
    }));
  }
};
